/*--------------------------------------------------------------------------------------------
Last Updated Date:	2012.03.19
Last Updated By:	hans.p.halvorsen@hit.no
Description:		School Tables

(C) Hans-Petter Halvorsen
-------------------------------------------------------------------------------------------*/

/*
SCHOOL
CLASS
COURSE
TEACHER
TEACHER_COURSE
STUDENT
STUDENT_COURSE
GRADE
*/

if not exists (select * from dbo.sysobjects where id = object_id(N'[SCHOOL]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [SCHOOL]
(
	[SchoolId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[SchoolName] [varchar](50) NOT NULL UNIQUE,
	[Description] [varchar](1000) NULL,
	[Address] [varchar](50) NULL,
	[Phone] [varchar](50) NULL,
	[PostCode] [varchar](50) NULL,
	[PostAddress] [varchar](50) NULL,
 
) 
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[CLASS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [CLASS]
(
	[ClassId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[SchoolId] [int] NOT NULL FOREIGN KEY REFERENCES [SCHOOL] ([SchoolId]),
	[ClassName] [varchar](50) NOT NULL,
	[Description] [varchar](1000) NULL,
	 
) 
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[COURSE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [COURSE]
(
	[CourseId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[CourseName] [varchar](50) NOT NULL,
	[SchoolId] [int] NOT NULL FOREIGN KEY REFERENCES [SCHOOL] ([SchoolId]),
	[Description] [varchar](1000) NULL,
	 
) 
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[TEACHER]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [TEACHER]
(
	[TeacherId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[SchoolId] [int] NOT NULL FOREIGN KEY REFERENCES [SCHOOL] ([SchoolId]),
	[TeacherName] [varchar](50) NOT NULL,
	[Description] [varchar](1000) NULL,
	 
) 
GO



if not exists (select * from dbo.sysobjects where id = object_id(N'[TEACHER_COURSE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [TEACHER_COURSE]
(
	[TeacherId] [int] NOT NULL FOREIGN KEY REFERENCES [TEACHER] ([TeacherId]),
	[CourseId] [int] NOT NULL FOREIGN KEY REFERENCES [COURSE] ([CourseId]),
		 
) 
GO



if not exists (select * from dbo.sysobjects where id = object_id(N'[STUDENT]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [STUDENT]
(
	[StudentId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[ClassId] [int] NOT NULL FOREIGN KEY REFERENCES [CLASS] ([ClassId]),
	[StudentName] [varchar](100) NOT NULL,
	[StudentNumber] [varchar](20) NOT NULL,
	[TotalGrade] [float] NULL,
	[Address] [varchar](100) NULL,
	[Phone] [varchar](20) NULL,
	[EMail] [varchar](100) NULL,
	 
) 
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[STUDENT_COURSE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [STUDENT_COURSE]
(
	[StudentId] [int] NOT NULL FOREIGN KEY REFERENCES [STUDENT] ([StudentId]),
	[CourseId] [int] NOT NULL FOREIGN KEY REFERENCES [COURSE] ([CourseId]),
		 
) 
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[GRADE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [GRADE]
(
	[GradeId] [int] IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	[StudentId] [int] NOT NULL FOREIGN KEY REFERENCES [STUDENT] ([StudentId]),
	[CourseId] [int] NOT NULL FOREIGN KEY REFERENCES [COURSE] ([CourseId]),
	[Grade] [float] NOT NULL,
	[Comment] [varchar](1000) NULL,
	 
) 
GO
